commit 3549a5cabdfd4ebb197da99f247d0abad0ba55b5
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Mar 3 10:42:34 2020 +0100

    explow: Fix ICE caused by plus_constant [PR94002]
    
    The following testcase ICEs in cross to riscv64-linux.  The problem is
    that we have a DImode integral constant (that doesn't fit into SImode),
    which is pushed into a constant pool and later access just the first half of
    it using a MEM.  When plus_constant is called on such a MEM, if the constant
    has mode, we verify the mode, but if it doesn't, we don't and ICE later on
    when we think the CONST_INT is a valid SImode constant.
    
    2020-03-03  Jakub Jelinek  <jakub@redhat.com>
    
            PR rtl-optimization/94002
            * explow.c (plus_constant): Punt if cst has VOIDmode and
            get_pool_mode is different from mode.
    
            * gcc.dg/pr94002.c: New test.
    
    (cherry picked from commit e913d4f4771e04d4254bf6c0e720fec5e324a898)

diff --git a/gcc/explow.c b/gcc/explow.c
index 72e52703c48..79c781cb390 100644
--- a/gcc/explow.c
+++ b/gcc/explow.c
@@ -129,6 +129,9 @@ plus_constant (machine_mode mode, rtx x, poly_int64 c, bool inplace)
 	      cst = gen_lowpart (mode, cst);
 	      gcc_assert (cst);
 	    }
+	  else if (GET_MODE (cst) == VOIDmode
+		   && get_pool_mode (XEXP (x, 0)) != mode)
+	    break;
 	  if (GET_MODE (cst) == VOIDmode || GET_MODE (cst) == mode)
 	    {
 	      tem = plus_constant (mode, cst, c);
diff --git a/gcc/testsuite/gcc.dg/pr94002.c b/gcc/testsuite/gcc.dg/pr94002.c
new file mode 100644
index 00000000000..05a02f3f15b
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr94002.c
@@ -0,0 +1,13 @@
+/* PR rtl-optimization/94002 */
+/* { dg-do compile } */
+/* { dg-options "-O1 -fno-tree-dce -fno-tree-reassoc" } */
+/* { dg-additional-options "-fPIC" { target fpic } } */
+
+unsigned a, b;
+
+void
+foo (void)
+{
+  __builtin_sub_overflow (b, 44852956282LL, &a);
+  a += ~b;
+}

